/*
******************************************************************************

The following lines should be added before and after the DcPrint ON line
They will add a [PDF] button to the preview window of DcPrint

      aButtons := array(13)
      aButtons[DCPRINT_BUTTON_FIND] := {60,20,'PDF'}


      DcPrint ON ..... parameters ..... Preview ....  buttons aButtons


      pObj := dc_PrinterObject()
      pObj:oFindButton:Activate := {||CreatePDF()}

******************************************************************************
*/




FUNCTION CreatePDF()

   LOCAL app := SetAppFocus(), oPobj := dc_PrinterObject()
   LOCAL c, i, l, n, fl, linha, pgf, xFont, yFont, cTrans
   LOCAL ci, li, cf, lf, pr, Bmp
   fl := 'XbpPDF.PDF'

   do while .t.
      oDlg := XbpFiledialog():New( app )
      oDlg:Title := "Save :"
      oDlg:Create()
      fl := oDlg:SaveAs( "*.PDF" )
      if fl <> NIL
         exit
      endif
   enddo

	axbppdf := aClone(oPobj:abuffer)
	
   pgf   := oPobj:nPage
   xfont := oPobj:aBuffer[1,1,2]
   // If no fontsize given, use 10 as default
   nSize := At(".",xfont)
   if nSize < 1
      xfont := "10."+xfont
   endif
	cTrans := NIL                    // Translation table for foreign codepages

   oPdf := xbpPdf():new( "put your key here" )
   oPdf:Create( fl )

   for j = 1 to pgf
      oPdf:NewPage( oPobj:nFormSize, , oPObj:nRows, oPobj:nCols )

		// translate to Norwegian character table
      oPdf:Font( xFont,,,cTrans )

      for i = 1 to len(oPobj:aBuffer[j])
         do case

            case oPobj:aBuffer[j,i,1] = 2         && Text
               linha := oPobj:aBuffer[j,i,4]
					if oPobj:aBuffer[j,i,2] <> NIL
	               l     := oPobj:aBuffer[j,i,2] + 1
					endif
               c     := oPobj:aBuffer[j,i,3]
               yFont := oPobj:aBuffer[j,i,9]

               if yFont <> NIL
                  oPdf:Font( yFont,,,cTrans )
               endif
					if oPobj:aBuffer[j,i,12] = 2
						oPdf:mText(l, c, linha, 1)
					else
						if oPobj:aBuffer[j,i,8]
							oPdf:mText(l, c+len(linha), linha, 1)
						else
		               oPdf:Text( l, c, linha )
						endif
					endif
               if yFont <> NIL
                  oPdf:Font( xFont,,,cTrans )
               endif

            case oPobj:aBuffer[j,i,1] = 3         && DcBox
               li    := oPobj:aBuffer[j,i,2] + 1
               ci    := oPobj:aBuffer[j,i,3]
               lf    := oPobj:aBuffer[j,i,4] + 1
               cf    := oPobj:aBuffer[j,i,5]
               pr    := 0
               if oPobj:aBuffer[j,i,6] <> NIL
                  pr := oPobj:aBuffer[j,i,9,1]
               endif
               oPdf:Box( li, ci, lf, cf, pr )

            case oPobj:aBuffer[j,i,1] = 4         && DcBitMap
					lRatio := .f.
					if oPobj:aBuffer[j,i,2] = NIL
						li := NIL
						lRatio := .t.
					else
	               li := oPobj:aBuffer[j,i,2] + 1
					endif
					if oPobj:aBuffer[j,i,3] = NIL
						ci := NIL
						lRatio := .t.
					else
	               ci := oPobj:aBuffer[j,i,3] + 1
					endif
					if oPobj:aBuffer[j,i,4] = NIL
						lf := NIL
						lRatio := .t.
					else
	               lf := oPobj:aBuffer[j,i,4] + 1
					endif
					if oPobj:aBuffer[j,i,5] = NIL
						cf := NIL
						lRatio := .t.
					else
	               cf := oPobj:aBuffer[j,i,5] + 1
					endif
               Bmp   := oPobj:aBuffer[j,i,6]
               oPdf:Image( li, ci, lf, cf, Bmp, lRatio )

            case oPobj:aBuffer[j,i,1] = 6         && DcLine
               li    := oPobj:aBuffer[j,i,2] + 1
               ci    := oPobj:aBuffer[j,i,3]
               lf    := oPobj:aBuffer[j,i,4] + 1
               cf    := oPobj:aBuffer[j,i,5]
               oPdf:Line( li, ci, lf, cf )

         endcase
      next

   next

   oPdf:EndDoc()

*  Option to open the PDF after creation,
*  You can remove the following line, if this is not wanted.

   DllCall( "SHELL32.DLL", DLL_STDCALL, ;
            "ShellExecuteA", AppDesktop():GetHWND(), "open", fl, "", "", 1 )

   setappfocus(app)

return(.t.)
